""" Module proposant une représentation ensembliste (index inversé) de l'indexations d'un corpus"""

def index_en_index_inverse(documents_mots: dict[str, list[str]]) -> dict[str, set[str]]:
    """ Calcul l'index inversé de documents décrits par une liste de mots.
        Args:
            documents_mots (dict[str, list[str]]): le corpus.
        Returns:
            dict[str, set[str]]: Un index inversé.
    """
    # A modifier
    return {}

def documents_contenant_mot(index_inverse: dict[str, set[str]], mot: str) -> set[str]:
    """ Retourne l'ensemble des documents contenant un mot.
        Args:
            index_inverse (dict[str, set[str]]): L'index inversé.
            mot (str): Le mot recherché.
        Returns:
            set[str]: L'ensemble des documents contenant le mot.
    """
    if mot not in index_inverse:
        return set()
    return index_inverse[mot]

def et(documents1: set[str], documents2: set[str]) -> set[str]:
    """ Retourne l'intersection de deux ensembles de documents.
        Args:
            documents1 (set[str]): Le premier ensemble de documents.
            documents2 (set[str]): Le second ensemble de documents.
        Returns:
            set[str]: L'intersection des deux ensembles.
    """
    # A modifier
    return set()


def ou(documents1: set[str], documents2: set[str]) -> set[str]:
    """ Retourne l'union de deux ensembles de documents.
        Args:
            documents1 (set[str]): Le premier ensemble de documents.
            documents2 (set[str]): Le second ensemble de documents.
        Returns:
            set[str]: L'union des deux ensembles.
    """
    # A modifier
    return set()

def non(documents: set[str], corpus: set[str]) -> set[str]:
    """ Retourne le complémentaire d'un ensemble de documents.
        Args:
            documents (set[str]): L'ensemble de documents.
            corpus (set[str]): L'ensemble de tous les documents.
        Returns:
            set[str]: Le complémentaire de l'ensemble.
    """
    # A modifier
    return set()    
